<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Geral\Logic\PropostaComercial;

/**
 * Description of EnviarPropostaEmail
 *
 * @author phillipesilva
 */

use Geral\Entities\Operador;
use Relatione\Entities\Evolcont;
use Setforms2\Shared\Registry;

class EnviarPropostaEmail {
    public static function enviarEmail($emailOpe, $emailCC, $assunto, $corpoMsg, $anxCheck, $email, $emailDe, $ccOculto)
    {
        $envio = \Setforms2\Shared\Notifier::factory();
        $notification = new \Setforms2\Shared\Business\Notification();
        
        $emailCC   = str_replace(array(' ', ';'), array('', ','), $emailCC);
        $email     = str_replace(array(' ', ';'), array('', ','), $email[0]);
        $emCCDados = explode(',', $emailCC);
        $emDados   = explode(',', $email);
        $ccOculto  = explode(',', $ccOculto);
        $anxDados  = explode(',', $anxCheck);

        $images    = '<img dfsrc="https://www.security.teknisa.com/_imagens/logtek.jpg" src="https://www.security.teknisa.com/_imagens/logtek.jpg"/>';
        $corpoMsg  = nl2br($corpoMsg);
        $corpoMsg  = $images.'<br/><br/>'.$corpoMsg;

        foreach($anxDados as &$anexo) {
            $anexo = htmlspecialchars($anexo);

            //Caracteres não permitidos em nomes de arquivos, caso a função acima os recrie.
            $anexo = str_replace(array('"', ':', ';', ',', '+', '>', '<'),
                                 array('', '', '', '', '', '', ''),
                                 $anexo);

            $anexo = realpath($anexo);
        }
        
            try 
            {
                //Com anexos e com CC
                if($anxDados[0] != '' && !(is_null($emailCC) || $emailCC == ''))
                {                  
                   $notification->setSubject($assunto);
                   $notification->setFrom($emailOpe);
                   $notification->setName($emailDe);
                   $notification->setTo($emDados);
                   $notification->setCc($emCCDados);
                   $notification->setBcc($ccOculto);
                   $notification->setBody($corpoMsg);
                   $notification->setAttachments($anxDados);
                   $envio->setNotificationBusiness($notification);               
                }
                //Com anexos e sem CC
                elseif($anxDados[0] != '' && (is_null($emailCC) || $emailCC == '') )
                {
                   $notification->setSubject($assunto);
                   $notification->setFrom($emailOpe);
                   $notification->setName($emailDe);
                   $notification->setTo($emDados);
                   $notification->setBcc($ccOculto);
                   $notification->setBody($corpoMsg);
                   $notification->setAttachments($anxDados);
                   $envio->setNotificationBusiness($notification);               
                }
                //Sem anexos e sem CC
                elseif($anxDados[0] == '' && !(is_null($emailCC) || $emailCC == ''))
                {
                   $notification->setSubject($assunto);
                   $notification->setFrom($emailOpe);
                   $notification->setName($emailDe);
                   $notification->setTo($emDados);
                   $notification->setBcc($ccOculto);
                   $notification->setBody($corpoMsg);
                   $envio->setNotificationBusiness($notification);               
                }
                //Sem anexos e com CC
                elseif($anxDados[0] == '' && (is_null($emailCC) || $emailCC == ''))
                {
                   $notification->setSubject($assunto);
                   $notification->setFrom($emailOpe);
                   $notification->setName($emailDe);
                   $notification->setTo($emDados);
                   $notification->setBcc($ccOculto);
                   $notification->setBody($corpoMsg);
                   $envio->setNotificationBusiness($notification);               
                }
                
                $envio->send();
                
            } catch (\Exception $e) {
                throw $e;
            }
    }
    
    public static function gravarEvolucaoContato($paramsEvolCont)
    {
        $numeroSequencialContato = Evolcont::getRepository()->numeroSequencialContato($paramsEvolCont['NRCONTATO']);
        $numeroSeqContato        = Evolcont::getRepository()->consultaProxCodigoSeqEvol();
        $seqContato = '01';
        
        if (isset($numeroSequencialContato[0])) {
            if ($numeroSequencialContato[0] != '' && $numeroSequencialContato[0] < 100) {
                $seqContato = $numeroSequencialContato[0] + 1;
            }
        }

        if($seqContato > 99 || strlen($seqContato) > 2) {
            $seqContato = '01';
        }

        $descricao = self::geraDescricaoEvolCont($paramsEvolCont);
        self::insertContatoEmail($paramsEvolCont, $seqContato, $numeroSeqContato[0], $descricao);
    }
    
    private static function geraDescricaoEvolCont($paramsEvolCont)
    {
        $emailCC = str_replace(array(' ', ';'), array('', ','), $paramsEvolCont['EMAILCC']);
        
        $descEmail   = 'Mensagem enviada por e-mail para: '.$paramsEvolCont['EMAILPARA'][0].','.$emailCC;
        $descAssunto = 'Com o assunto: '.$paramsEvolCont['ASSUNTO'];
        $descMsg     = 'Contendo a seguinte Mensagem: '.$paramsEvolCont['CORPOMSG'];
        $descricao   = $descEmail.'. '.$descAssunto.'. '.rtrim($descMsg).'.';
        
        return $descricao;
    }
    
    public static function insertContatoEmail($paramsEvolCont, $seqContato, $numeroSeqContato, $descricao)
    {        
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();

        try {
            $evolCont = new Evolcont();

            $evolCont->setDthrevolcont($paramsEvolCont['DATAATUAL']);
            $evolCont->setCdoperevol($paramsEvolCont['CDOPERADOR']);
            $evolCont->setNmintevocont($paramsEvolCont['NMINTE']);
            $evolCont->setDtinclusao($paramsEvolCont['DATAATUAL']);
            $evolCont->setNrcontato($paramsEvolCont['NRCONTATO']);
            $evolCont->setCdfilial($paramsEvolCont['CDFILIAL']);
            $evolCont->setNrorg($paramsEvolCont['NRORG']);
            $evolCont->setNrseqevolcont($numeroSeqContato['NRSEQEVOLCONT']);
            $evolCont->setNrseqevolcon(str_pad($seqContato, 2, '0', STR_PAD_LEFT));
            $evolCont->setDsevolcont($descricao);
            $evolCont->setCdmotievocon('00003');
            $evolCont->setIdageevocont('N');
            $evolCont->setIdsenevocont('S');
            $evolCont->setIdtpevolcont('P');
            $evolCont->setCdtipocont('11');
            $evolCont->setIddescprot('S');

            if ($paramsEvolCont['ANEXOS'] == '') {
                $evolCont->setIdanexoevol('N');
            } else {
                $evolCont->setIdanexoevolcont('S');
            }

            if ($paramsEvolCont['IDCLIENPROSP'] == 'C') {
                $evolCont->setCdcliente($paramsEvolCont['CDCLIPROSP']);
            } else {
                $evolCont->setCdprospect($paramsEvolCont['CDCLIPROSP']);
            }

            $evolCont->persist();

            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollBack();
            throw $e;
        }
    }
}
